OpenShot Audio Library | OpenShotAudio: juce::CharPointer_ASCII Class Reference

OpenShot Audio Library | OpenShotAudio 0.3.2

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | List of all members
juce::CharPointer_ASCII Class Referencefinal

`#include <juce_CharPointer_ASCII.h>`

## Public Types
using | CharType = char

## Public Member Functions
| CharPointer_ASCII (const CharType *rawPointer) noexcept
| CharPointer_ASCII (const CharPointer_ASCII &other)=default
CharPointer_ASCII | operator= (const CharPointer_ASCII other) noexcept
CharPointer_ASCII | operator= (const CharType *text) noexcept
bool | operator== (CharPointer_ASCII other) const noexcept
bool | operator!= (CharPointer_ASCII other) const noexcept
bool | operator<= (CharPointer_ASCII other) const noexcept
bool | operator< (CharPointer_ASCII other) const noexcept
bool | operator>= (CharPointer_ASCII other) const noexcept
bool | operator> (CharPointer_ASCII other) const noexcept
CharType * | getAddress () const noexcept
| operator const CharType * () const noexcept
bool | isEmpty () const noexcept
bool | isNotEmpty () const noexcept
juce_wchar | operator* () const noexcept
CharPointer_ASCII | operator++ () noexcept
CharPointer_ASCII | operator-- () noexcept
juce_wchar | getAndAdvance () noexcept
CharPointer_ASCII | operator++ (int) noexcept
void | operator+= (const int numToSkip) noexcept
void | operator-= (const int numToSkip) noexcept
juce_wchar | operator[] (const int characterIndex) const noexcept
CharPointer_ASCII | operator+ (const int numToSkip) const noexcept
CharPointer_ASCII | operator- (const int numToSkip) const noexcept
void | write (const juce_wchar charToWrite) noexcept
void | replaceChar (const juce_wchar newChar) noexcept
void | writeNull () const noexcept
size_t | length () const noexcept
size_t | lengthUpTo (const size_t maxCharsToCount) const noexcept
size_t | lengthUpTo (const CharPointer_ASCII end) const noexcept
size_t | sizeInBytes () const noexcept
CharPointer_ASCII | findTerminatingNull () const noexcept
template<typename CharPointer >
void | writeAll (const CharPointer src) noexcept
template<typename CharPointer >
size_t | writeWithDestByteLimit (const CharPointer src, const size_t maxDestBytes) noexcept
template<typename CharPointer >
void | writeWithCharLimit (const CharPointer src, const int maxChars) noexcept
template<typename CharPointer >
int | compare (const CharPointer other) const noexcept
int | compare (const CharPointer_ASCII other) const noexcept
template<typename CharPointer >
int | compareUpTo (const CharPointer other, const int maxChars) const noexcept
int | compareUpTo (const CharPointer_ASCII other, const int maxChars) const noexcept
template<typename CharPointer >
int | compareIgnoreCase (const CharPointer other) const
int | compareIgnoreCase (const CharPointer_ASCII other) const
template<typename CharPointer >
int | compareIgnoreCaseUpTo (const CharPointer other, const int maxChars) const noexcept
template<typename CharPointer >
int | indexOf (const CharPointer stringToFind) const noexcept
int | indexOf (const juce_wchar charToFind) const noexcept
int | indexOf (const juce_wchar charToFind, const bool ignoreCase) const noexcept
bool | isWhitespace () const
bool | isDigit () const
bool | isLetter () const
bool | isLetterOrDigit () const
bool | isUpperCase () const
bool | isLowerCase () const
juce_wchar | toUpperCase () const noexcept
juce_wchar | toLowerCase () const noexcept
int | getIntValue32 () const noexcept
int64 | getIntValue64 () const noexcept
double | getDoubleValue () const noexcept
CharPointer_ASCII | findEndOfWhitespace () const noexcept

## Static Public Member Functions
static size_t | getBytesRequiredFor (const juce_wchar) noexcept
template<class CharPointer >
static size_t | getBytesRequiredFor (const CharPointer text) noexcept
static bool | canRepresent (juce_wchar character) noexcept
static bool | isValidString (const CharType *dataToTest, int maxBytesToRead)

## Detailed Description

Wraps a pointer to a null-terminated ASCII character string, and provides various methods to operate on the data.

A valid ASCII string is assumed to not contain any characters above 127.

See also
  CharPointer_UTF8, CharPointer_UTF16, CharPointer_UTF32

Definition at line 37 of file juce_CharPointer_ASCII.h.

## Member Typedef Documentation

## ◆ CharType

using juce::CharPointer_ASCII::CharType = char

Definition at line 40 of file juce_CharPointer_ASCII.h.

## Constructor & Destructor Documentation

## ◆ CharPointer_ASCII()

juce::CharPointer_ASCII::CharPointer_ASCII | ( | const CharType * | rawPointer | ) |
| inlineexplicitnoexcept

Definition at line 42 of file juce_CharPointer_ASCII.h.

## Member Function Documentation

## ◆ canRepresent()

static bool juce::CharPointer_ASCII::canRepresent | ( | juce_wchar | character | ) |
| inlinestaticnoexcept

Returns true if the given unicode character can be represented in this encoding.

Definition at line 354 of file juce_CharPointer_ASCII.h.

## ◆ compare() [1/2]

template<typename CharPointer >

int juce::CharPointer_ASCII::compare | ( | const CharPointer | other | ) | const
| inlinenoexcept

Compares this string with another one.

Definition at line 235 of file juce_CharPointer_ASCII.h.

## ◆ compare() [2/2]

int juce::CharPointer_ASCII::compare | ( | const CharPointer_ASCII | other | ) | const
| inlinenoexcept

Compares this string with another one.

Definition at line 241 of file juce_CharPointer_ASCII.h.

## ◆ compareIgnoreCase() [1/2]

template<typename CharPointer >

int juce::CharPointer_ASCII::compareIgnoreCase | ( | const CharPointer | other | ) | const
| inline

Compares this string with another one.

Definition at line 261 of file juce_CharPointer_ASCII.h.

## ◆ compareIgnoreCase() [2/2]

int juce::CharPointer_ASCII::compareIgnoreCase | ( | const CharPointer_ASCII | other | ) | const
| inline

Definition at line 266 of file juce_CharPointer_ASCII.h.

## ◆ compareIgnoreCaseUpTo()

template<typename CharPointer >

int juce::CharPointer_ASCII::compareIgnoreCaseUpTo | ( | const CharPointer | other,
|  | const int | maxChars
| ) |  | const
| inlinenoexcept

Compares this string with another one, up to a specified number of characters.

Definition at line 279 of file juce_CharPointer_ASCII.h.

## ◆ compareUpTo() [1/2]

template<typename CharPointer >

int juce::CharPointer_ASCII::compareUpTo | ( | const CharPointer | other,
|  | const int | maxChars
| ) |  | const
| inlinenoexcept

Compares this string with another one, up to a specified number of characters.

Definition at line 248 of file juce_CharPointer_ASCII.h.

## ◆ compareUpTo() [2/2]

int juce::CharPointer_ASCII::compareUpTo | ( | const CharPointer_ASCII | other,
|  | const int | maxChars
| ) |  | const
| inlinenoexcept

Compares this string with another one, up to a specified number of characters.

Definition at line 254 of file juce_CharPointer_ASCII.h.

## ◆ findEndOfWhitespace()

CharPointer_ASCII juce::CharPointer_ASCII::findEndOfWhitespace | ( |  | ) | const
| inlinenoexcept

Returns the first non-whitespace character in the string.

Definition at line 351 of file juce_CharPointer_ASCII.h.

## ◆ findTerminatingNull()

CharPointer_ASCII juce::CharPointer_ASCII::findTerminatingNull | ( |  | ) | const
| inlinenoexcept

Returns a pointer to the null character that terminates this string.

Definition at line 201 of file juce_CharPointer_ASCII.h.

## ◆ getAddress()

CharType * juce::CharPointer_ASCII::getAddress | ( |  | ) | const
| inlinenoexcept

Returns the address that this pointer is pointing to.

Definition at line 70 of file juce_CharPointer_ASCII.h.

## ◆ getAndAdvance()

juce_wchar juce::CharPointer_ASCII::getAndAdvance | ( |  | ) |
| inlinenoexcept

Returns the character that this pointer is currently pointing to, and then advances the pointer to point to the next character.

Definition at line 100 of file juce_CharPointer_ASCII.h.

## ◆ getBytesRequiredFor() [1/2]

template<class CharPointer >

static size_t juce::CharPointer_ASCII::getBytesRequiredFor | ( | const CharPointer | text | ) |
| inlinestaticnoexcept

Returns the number of bytes that would be needed to represent the given string in this encoding format. The value returned does NOT include the terminating null character.

Definition at line 195 of file juce_CharPointer_ASCII.h.

## ◆ getBytesRequiredFor() [2/2]

static size_t juce::CharPointer_ASCII::getBytesRequiredFor | ( | const | juce_wchar | ) |
| inlinestaticnoexcept

Returns the number of bytes that would be needed to represent the given unicode character in this encoding format.

Definition at line 185 of file juce_CharPointer_ASCII.h.

## ◆ getDoubleValue()

double juce::CharPointer_ASCII::getDoubleValue | ( |  | ) | const
| inlinenoexcept

Parses this string as a floating point double.

Definition at line 348 of file juce_CharPointer_ASCII.h.

## ◆ getIntValue32()

int juce::CharPointer_ASCII::getIntValue32 | ( |  | ) | const
| inlinenoexcept

Parses this string as a 32-bit integer.

Definition at line 333 of file juce_CharPointer_ASCII.h.

## ◆ getIntValue64()

int64 juce::CharPointer_ASCII::getIntValue64 | ( |  | ) | const
| inlinenoexcept

Parses this string as a 64-bit integer.

Definition at line 336 of file juce_CharPointer_ASCII.h.

## ◆ indexOf() [1/3]

template<typename CharPointer >

int juce::CharPointer_ASCII::indexOf | ( | const CharPointer | stringToFind | ) | const
| inlinenoexcept

Returns the character index of a substring, or -1 if it isn't found.

Definition at line 286 of file juce_CharPointer_ASCII.h.

## ◆ indexOf() [2/3]

int juce::CharPointer_ASCII::indexOf | ( | const juce_wchar | charToFind | ) | const
| inlinenoexcept

Returns the character index of a unicode character, or -1 if it isn't found.

Definition at line 292 of file juce_CharPointer_ASCII.h.

## ◆ indexOf() [3/3]

int juce::CharPointer_ASCII::indexOf | ( | const juce_wchar | charToFind,
|  | const bool | ignoreCase
| ) |  | const
| inlinenoexcept

Returns the character index of a unicode character, or -1 if it isn't found.

Definition at line 308 of file juce_CharPointer_ASCII.h.

## ◆ isDigit()

bool juce::CharPointer_ASCII::isDigit | ( |  | ) | const
| inline

Returns true if the first character of this string is a digit.

Definition at line 317 of file juce_CharPointer_ASCII.h.

## ◆ isEmpty()

bool juce::CharPointer_ASCII::isEmpty | ( |  | ) | const
| inlinenoexcept

Returns true if this pointer is pointing to a null character.

Definition at line 76 of file juce_CharPointer_ASCII.h.

## ◆ isLetter()

bool juce::CharPointer_ASCII::isLetter | ( |  | ) | const
| inline

Returns true if the first character of this string is a letter.

Definition at line 319 of file juce_CharPointer_ASCII.h.

## ◆ isLetterOrDigit()

bool juce::CharPointer_ASCII::isLetterOrDigit | ( |  | ) | const
| inline

Returns true if the first character of this string is a letter or digit.

Definition at line 321 of file juce_CharPointer_ASCII.h.

## ◆ isLowerCase()

bool juce::CharPointer_ASCII::isLowerCase | ( |  | ) | const
| inline

Returns true if the first character of this string is lower-case.

Definition at line 325 of file juce_CharPointer_ASCII.h.

## ◆ isNotEmpty()

bool juce::CharPointer_ASCII::isNotEmpty | ( |  | ) | const
| inlinenoexcept

Returns true if this pointer is not pointing to a null character.

Definition at line 79 of file juce_CharPointer_ASCII.h.

## ◆ isUpperCase()

bool juce::CharPointer_ASCII::isUpperCase | ( |  | ) | const
| inline

Returns true if the first character of this string is upper-case.

Definition at line 323 of file juce_CharPointer_ASCII.h.

## ◆ isValidString()

static bool juce::CharPointer_ASCII::isValidString | ( | const CharType * | dataToTest,
|  | int | maxBytesToRead
| ) |  |
| inlinestatic

Returns true if this data contains a valid string in this encoding.

Definition at line 360 of file juce_CharPointer_ASCII.h.

Referenced by juce::String::String(), and juce::StringRef::StringRef().

## ◆ isWhitespace()

bool juce::CharPointer_ASCII::isWhitespace | ( |  | ) | const
| inline

Returns true if the first character of this string is whitespace.

Definition at line 315 of file juce_CharPointer_ASCII.h.

## ◆ length()

size_t juce::CharPointer_ASCII::length | ( |  | ) | const
| inlinenoexcept

Returns the number of characters in this string.

Definition at line 157 of file juce_CharPointer_ASCII.h.

Referenced by findTerminatingNull(), and sizeInBytes().

## ◆ lengthUpTo() [1/2]

size_t juce::CharPointer_ASCII::lengthUpTo | ( | const CharPointer_ASCII | end | ) | const
| inlinenoexcept

Returns the number of characters in this string, or up to the given end pointer, whichever is lower.

Definition at line 169 of file juce_CharPointer_ASCII.h.

## ◆ lengthUpTo() [2/2]

size_t juce::CharPointer_ASCII::lengthUpTo | ( | const size_t | maxCharsToCount | ) | const
| inlinenoexcept

Returns the number of characters in this string, or the given value, whichever is lower.

Definition at line 163 of file juce_CharPointer_ASCII.h.

## ◆ operator const CharType *()

juce::CharPointer_ASCII::operator const CharType * | ( |  | ) | const
| inlinenoexcept

Returns the address that this pointer is pointing to.

Definition at line 73 of file juce_CharPointer_ASCII.h.

## ◆ operator!=()

bool juce::CharPointer_ASCII::operator!= | ( | CharPointer_ASCII | other | ) | const
| inlinenoexcept

Definition at line 63 of file juce_CharPointer_ASCII.h.

## ◆ operator*()

juce_wchar juce::CharPointer_ASCII::operator* | ( |  | ) | const
| inlinenoexcept

Returns the unicode character that this pointer is pointing to.

Definition at line 82 of file juce_CharPointer_ASCII.h.

## ◆ operator+()

CharPointer_ASCII juce::CharPointer_ASCII::operator+ | ( | const int | numToSkip | ) | const
| inlinenoexcept

Returns a pointer which is moved forwards from this one by the specified number of characters.

Definition at line 128 of file juce_CharPointer_ASCII.h.

## ◆ operator++() [1/2]

CharPointer_ASCII juce::CharPointer_ASCII::operator++ | ( |  | ) |
| inlinenoexcept

Moves this pointer along to the next character in the string.

Definition at line 85 of file juce_CharPointer_ASCII.h.

## ◆ operator++() [2/2]

CharPointer_ASCII juce::CharPointer_ASCII::operator++ | ( | int |  | ) |
| inlinenoexcept

Moves this pointer along to the next character in the string.

Definition at line 103 of file juce_CharPointer_ASCII.h.

## ◆ operator+=()

void juce::CharPointer_ASCII::operator+= | ( | const int | numToSkip | ) |
| inlinenoexcept

Moves this pointer forwards by the specified number of characters.

Definition at line 111 of file juce_CharPointer_ASCII.h.

## ◆ operator-()

CharPointer_ASCII juce::CharPointer_ASCII::operator- | ( | const int | numToSkip | ) | const
| inlinenoexcept

Returns a pointer which is moved backwards from this one by the specified number of characters.

Definition at line 134 of file juce_CharPointer_ASCII.h.

## ◆ operator--()

CharPointer_ASCII juce::CharPointer_ASCII::operator-- | ( |  | ) |
| inlinenoexcept

Moves this pointer to the previous character in the string.

Definition at line 92 of file juce_CharPointer_ASCII.h.

## ◆ operator-=()

void juce::CharPointer_ASCII::operator-= | ( | const int | numToSkip | ) |
| inlinenoexcept

Definition at line 116 of file juce_CharPointer_ASCII.h.

## ◆ operator<()

bool juce::CharPointer_ASCII::operator< | ( | CharPointer_ASCII | other | ) | const
| inlinenoexcept

Definition at line 65 of file juce_CharPointer_ASCII.h.

## ◆ operator<=()

bool juce::CharPointer_ASCII::operator<= | ( | CharPointer_ASCII | other | ) | const
| inlinenoexcept

Definition at line 64 of file juce_CharPointer_ASCII.h.

## ◆ operator=() [1/2]

CharPointer_ASCII juce::CharPointer_ASCII::operator= | ( | const CharPointer_ASCII | other | ) |
| inlinenoexcept

Definition at line 49 of file juce_CharPointer_ASCII.h.

## ◆ operator=() [2/2]

CharPointer_ASCII juce::CharPointer_ASCII::operator= | ( | const CharType * | text | ) |
| inlinenoexcept

Definition at line 55 of file juce_CharPointer_ASCII.h.

## ◆ operator==()

bool juce::CharPointer_ASCII::operator== | ( | CharPointer_ASCII | other | ) | const
| inlinenoexcept

This is a pointer comparison, it doesn't compare the actual text.

Definition at line 62 of file juce_CharPointer_ASCII.h.

## ◆ operator>()

bool juce::CharPointer_ASCII::operator> | ( | CharPointer_ASCII | other | ) | const
| inlinenoexcept

Definition at line 67 of file juce_CharPointer_ASCII.h.

## ◆ operator>=()

bool juce::CharPointer_ASCII::operator>= | ( | CharPointer_ASCII | other | ) | const
| inlinenoexcept

Definition at line 66 of file juce_CharPointer_ASCII.h.

## ◆ operator[]()

juce_wchar juce::CharPointer_ASCII::operator[] | ( | const int | characterIndex | ) | const
| inlinenoexcept

Returns the character at a given character index from the start of the string.

Definition at line 122 of file juce_CharPointer_ASCII.h.

## ◆ replaceChar()

void juce::CharPointer_ASCII::replaceChar | ( | const juce_wchar | newChar | ) |
| inlinenoexcept

Definition at line 145 of file juce_CharPointer_ASCII.h.

## ◆ sizeInBytes()

size_t juce::CharPointer_ASCII::sizeInBytes | ( |  | ) | const
| inlinenoexcept

Returns the number of bytes that are used to represent this string. This includes the terminating null character.

Definition at line 177 of file juce_CharPointer_ASCII.h.

## ◆ toLowerCase()

juce_wchar juce::CharPointer_ASCII::toLowerCase | ( |  | ) | const
| inlinenoexcept

Returns a lower-case version of the first character of this string.

Definition at line 330 of file juce_CharPointer_ASCII.h.

## ◆ toUpperCase()

juce_wchar juce::CharPointer_ASCII::toUpperCase | ( |  | ) | const
| inlinenoexcept

Returns an upper-case version of the first character of this string.

Definition at line 328 of file juce_CharPointer_ASCII.h.

## ◆ write()

void juce::CharPointer_ASCII::write | ( | const juce_wchar | charToWrite | ) |
| inlinenoexcept

Writes a unicode character to this string, and advances this pointer to point to the next position.

Definition at line 140 of file juce_CharPointer_ASCII.h.

## ◆ writeAll()

template<typename CharPointer >

void juce::CharPointer_ASCII::writeAll | ( | const CharPointer | src | ) |
| inlinenoexcept

Copies a source string to this pointer, advancing this pointer as it goes.

Definition at line 208 of file juce_CharPointer_ASCII.h.

## ◆ writeNull()

void juce::CharPointer_ASCII::writeNull | ( |  | ) | const
| inlinenoexcept

Writes a null character to this string (leaving the pointer's position unchanged).

Definition at line 151 of file juce_CharPointer_ASCII.h.

## ◆ writeWithCharLimit()

template<typename CharPointer >

void juce::CharPointer_ASCII::writeWithCharLimit | ( | const CharPointer | src,
|  | const int | maxChars
| ) |  |
| inlinenoexcept

Copies a source string to this pointer, advancing this pointer as it goes. The maxChars parameter specifies the maximum number of characters that can be written to the destination buffer before stopping (including the terminating null).

Definition at line 228 of file juce_CharPointer_ASCII.h.

## ◆ writeWithDestByteLimit()

template<typename CharPointer >

size_t juce::CharPointer_ASCII::writeWithDestByteLimit | ( | const CharPointer | src,
|  | const size_t | maxDestBytes
| ) |  |
| inlinenoexcept

Copies a source string to this pointer, advancing this pointer as it goes. The maxDestBytes parameter specifies the maximum number of bytes that can be written to the destination buffer before stopping.

Definition at line 218 of file juce_CharPointer_ASCII.h.

The documentation for this class was generated from the following file:

- juce_CharPointer_ASCII.h